import numpy as np
import matplotlib.pyplot as plt
plt.ion()

##############

def calc_d(A):
	dA = []
	for p,a1,a2 in zip(x[:-1],A[:-1],A[1:]):
		if not a1==a2: dA.append(p)
	return np.array(dA)

def a(x,A):
	dA = calc_d(A)
	holes = [dA[np.argmin(np.abs(z-dA))] for z in x]
	return (1-A)*x + A*holes
	# return holes

def highlight_ban(A,ymin=-5,ymax=5):
	dA = calc_d(A)
	for i,(a1,a2) in enumerate(zip(dA[:-1],dA[1:])):
		if i%2==0:
			plt.fill_between([ymin,ymax,ymax,ymin], [a1,a1,a2,a2], color="red",alpha=0.1,linewidth=0.0)

def blur(x,mask,N=1,k=64):
	hat = 1-np.abs(np.linspace(-1,1,k+1))
	hat = hat / sum(hat)
	out = x
	for n in range(N):
		out = np.convolve(out,hat,'same')
		out[-k:-1]=x[-k:-1]
		out[0:k]=x[0:k]
	out = x*mask + out*(1-mask)
	return out

##############

x = np.linspace(-5,5,2**15)
# A = 1*(-3<x)*(x<-2) + 1*(-1<x)*(x<.5) + 1*(1<x)*(x<3)
A = 1*(-3<x)*(x<1) + 1*(2<x)*(x<3)
A = 1*(A>0)

dA = calc_d(A)

##############

plt.close("all")
plt.figure(figsize=(5,5))
plt.clf()
plt.plot(x,x)
plt.plot(x,a(x,A))

highlight_ban(A)

plt.xlabel("input")
plt.ylabel("input avec région bannie")
plt.savefig("viz_smoothmax.png")

# plt.plot(np.convolve(hat,hat))
# plt.plot(hat)

###################################

# x = np.linspace(0,3,1024)
# λ=2
# plt.clf()
# plt.plot(x,λ*(1-np.exp(-x/λ)))
# plt.plot([0,3],[λ,λ])
# plt.plot(x,x)

def smexp_L(x,x0,λ):
	x1 = x0-λ
	out = x1 + λ*(1-np.exp((x1-x)/λ))
	return out*(out>x1) + x*(out<=x1)

def smexp_R(x,x0,λ):
	λ=-λ
	x1 = x0-λ
	out = x1 + λ*(1-np.exp((x1-x)/λ))
	return out*(out<x1) + x*(out>=x1)

def ban_LR(x,x0,x0l,x0r,λl,λr):
	# left = (x0l-λl<x)*(x<x0)
	# right = (x0<=x)*(x<x0r+λr)
	# other = 1-((left+right)>0)
	# return other*x + left*smexp_L(x,x0l,λl) + right*smexp_R(x,x0r,λr)
	left  = (x<x0)
	right = (x0<=x)
	return left*smexp_L(x,x0l,λl) + right*smexp_R(x,x0r,λr)

def smexp(x,A,λλ):
	dA = calc_d(A)
	ban_dA = [ [a1,a2] for i,(a1,a2) in enumerate(zip(dA[:-1],dA[1:]))if i%2==0]
	out = x
	# TODO : il faudrait plutôt "couper par morceau"
	#        la composition "déforme" au voisinage
	for l,r in ban_dA:
		x0 = (l+r)/2
		λ = (r-l)/2
		out = ban_LR(out,x0,x0-λ,x0+λ,λλ,λλ)
	return out

plt.close("all")
plt.figure(figsize=(5,5))
plt.clf()
plt.plot(x,x)
for λ in np.linspace(0,2,8):
	plt.plot(x,smexp(x,A,λ),linewidth=1)

highlight_ban(A)

plt.xlabel("input")
plt.ylabel("input avec région bannie")
plt.savefig("viz_smoothmax_exp.png")


# x = np.linspace(0,3,1024)
# x0=1
# λ=.5
# plt.clf()
# plt.plot(x,x)
# plt.plot([x0,x0],[0,3])
# plt.plot(x,smexp_L(x,x0,λ))
# plt.plot(x,smexp_R(x,x0,λ))
# plt.plot(x,ban_LR(x,x0,λ,λ))

def blur(x,A,N=1,k=64):
	hat = 1-np.abs(np.linspace(-1,1,k+1))
	hat = hat / sum(hat)
	#
	dA = calc_d(A)
	ban_dA = [ [a1,a2] for i,(a1,a2) in enumerate(zip(dA[:-1],dA[1:]))if i%2==0]
	mask = np.ones(x.shape)
	for l,r in ban_dA:
		x0 = (l+r)/2
		λ = (r-l)/2
		#
		mask = mask*(np.abs((x-x0))>λ/8)
		#
		# mask_λ = λ/4
		# mask2 = (np.abs((x-x0))>(mask_λ))
		# mask = mask*np.power(np.abs((x-x0)/mask_λ),0.1)*(1-mask2) + mask*mask2
	# return 1-mask
	aaa = a(x,A)
	out = aaa
	for n in range(N):
		out = np.convolve(out,hat,'same')
		out[-k:-1]=x[-k:-1]
		out[0:k]=x[0:k]
		out = out*mask + aaa*(1-mask)
	return out

plt.close("all")
plt.figure(figsize=(5,5))
plt.clf()
plt.plot(x,x)
highlight_ban(A)
# plt.plot(x,blur(x,A,2048,64))
for k in 4**np.arange(1,5):
	plt.plot(x,blur(x,A,2048,k))

plt.xlabel("input")
plt.ylabel("input avec région bannie")
plt.savefig("viz_smoothmax_masked_blur.png")
